
 
/**
 * Write a description of class StampChange here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
class stampchange
{
    public  static int LETTER=49;	// postage as of January 2017
    public  static int CARD=34;
    public  static int PENNY=1;
    public static int callCount = 0;
    
    public static void main(String[] args) {
  	int N = 10;
	if (args.length > 0) {
		N = new Integer(args[0]);
		System.out.printf("N is %d%n", N);
	}
        long starttime = System.currentTimeMillis();
	int result = stampCount1(N);
        System.out.printf("stampCount(%d) = %d; there were %d calls taking %d ms%n", N, result, callCount, System.currentTimeMillis() - starttime);
   }

    public static int stampCount1(int amount) {
        callCount=0;
        int result = stampCount1inner(amount);
        return result;
    }
    
    private static int stampCount1inner(int amount) {
    // pre: amount >= 0
    // post: return *number* of stamps needed to make change
    //       (only use letter, card, and penny stamps)
        callCount++;
        int minStamps;
        //Assert.pre(amount >= 0,"Reasonable amount of change.");
        if (amount == 0) return 0;
        // consider use of a penny stamp
        minStamps = 1+stampCount1inner(amount-PENNY);
        // consider use of a post card stamp
        if (amount >= CARD) {
            int possible = 1+stampCount1inner(amount-CARD);
            if (minStamps > possible) minStamps = possible;
        }
        // consider use of a letter stamp
        if (amount >= LETTER) {
            int possible = 1+stampCount1inner(amount-LETTER);
            if (minStamps > possible) minStamps = possible;
        }
        return minStamps;
    }

    public static int stampCount2(int amount)
    // pre: amount >= 0
    // post: return *number* of stamps needed to make change
    //       (only use letter, post card, and penny stamps)
    {
        return stampCount2(amount, new int[amount+1]);
    }
    private static int stampCount2(int amount, int[] answer) {
    // pre: amount >= 0; answer array has length >= amount
    // post: return *number* of stamps needed to make change
    //       (only use letter, post card, and penny stamps)
        int minStamps;
        callCount++;
        //Assert.pre(amount >= 0,"Reasonable amount of change.");
        if (amount == 0) return 0;
        if (answer[amount] != 0) return answer[amount];
        // consider use of a penny stamp
        minStamps = 1+stampCount2(amount-1,answer);
        // consider use of a post card stamp
        if (amount >= CARD) {
            int possible = 1+stampCount2(amount-CARD,answer);
            if (minStamps > possible) minStamps = possible;
        }
        // consider use of a letter stamp
        if (amount >= LETTER) {
            int possible = 1+stampCount2(amount-LETTER,answer);
            if (minStamps > possible) minStamps = possible;
        }
        answer[amount] = minStamps;
	System.out.printf("answer[%d] = %d%n", amount, minStamps);
        return minStamps;
    }

}